/*
 * Created by SharpDevelop.
 * User: たかみちえ
 * Date: 2006/03/19
 * Time: 21:16
 */

using System;
using System.IO;

namespace Chie.m3uCome
{
  public struct ConvertMIDI2MP3
  {
    public bool Enabled;
    public string TimidityPath;
    public string Gogo_8hzPath;
    public ConvertMIDI2MP3(bool Enabled, string Gogo_8hzPath, string TimidityPath)
    {
      this.Enabled = Enabled;
      this.Gogo_8hzPath = Gogo_8hzPath;
      this.TimidityPath = TimidityPath;
    }
  }

	/// <summary>
	/// 実際のファイルコピー処理を行うクラスです
	/// </summary>
	public sealed class FileCopyProsecutor
	{
	  private StreamWriter stream = null;
	  private string dirName      = "";
	  private System.Windows.Forms.ListView.ListViewItemCollection items = null;
	  private string savePlayList = "";
	  private bool copyOnlyMP3    = false;
	  private ConvertMIDI2MP3 convertMIDI2MP3 = new ConvertMIDI2MP3();
	  
		public FileCopyProsecutor(string dirName, 
	                            System.Windows.Forms.ListView.ListViewItemCollection items)
		{
	    this.dirName = dirName;
	    this.items   = items;  
		}
		
	  #region プロパティ
	  
	  public string SavePlayList 
	  {
	    get { return savePlayList; }
	    set { savePlayList = value; }
	  }
	  public ConvertMIDI2MP3 ConvertMIDI2MP3 
	  {
	    get { return convertMIDI2MP3; }
	    set { convertMIDI2MP3 = value; }
	  }
	  public bool CopyOnlyMP3 
	  {
	    get { return copyOnlyMP3; }
	    set { copyOnlyMP3 = value; }
	  }
	  public string DirName 
	  {
	    get { return dirName; }
	    set { dirName = value; }
	  }
	  public System.Windows.Forms.ListView.ListViewItemCollection Items 
	  {
	    get { return items; }
	    set { items = value; }
	  }
	  
	  #endregion
	  
		public void Do()
		{        
		  // コピー
      if(savePlayList != "")
        stream= new StreamWriter(Path.Combine(dirName, savePlayList),
                                 false,
                                 System.Text.Encoding.Default);
      try
      {                              
        foreach(MainForm.SongListItem si in items)
        {
          if(copyOnlyMP3)
          {
            switch(Path.GetExtension(si.FileName).ToLower())
            {
              case ".mp3":
              case ".wmv":
                break;
              default:
                continue;
            }
          }
          if(stream != null) stream.WriteLine(Path.GetFileName(si.FileName));
          File.Copy(si.FileName, Path.Combine(dirName, si.Text));
        }
      }
      finally
      {
        if(stream != null) stream.Close();
      }
	  }
	}
}
