﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Chie.m3uCome
{
  public partial class SettingDialog : Form
  {
    public SettingDialog()
    {
      InitializeComponent();
    }

    private void referButton_Click(object sender, EventArgs e)
    {
      string dir = copyDirectory.Text;
      if(Chie.Dialog.SelectDirectory("フォルダを選択してください",
                                    Environment.SpecialFolder.Desktop,
                                    ref dir,
                                    true))
        copyDirectory.Text = dir;
    }

    /// <summary><see cref="Setting"/>構造体から設定を読み込みます</summary>
    /// <param name="setting">設定の格納された<see cref="Setting"/>構造体</param>
    public void LoadSetting(Setting setting)
    {
      this.copyDirectory.Items.AddRange(setting.DirList);
      this.copyDirectory.Text = setting.CopyDirectory;
      this.createM3u.Checked = setting.CreateM3U;
      this.mp3Only.Checked = setting.MP3Only;
      this.autoTestPlay.Checked = setting.AutoTestPlay;
    }

    /// <summary><see cref="Setting"/>構造体に設定を書き込みます</summary>
    /// <param name="setting">設定を格納する<see cref="Setting"/>構造体</param>
    public void SaveSetting(Setting setting)
    {
      List<string> list = new List<string>();
      // 入力したディレクトリが未知のものならば、リストに追加
      if(Directory.Exists(copyDirectory.Text) && 
            copyDirectory.Items.IndexOf(copyDirectory.Text) == -1)
            list.Add(copyDirectory.Text);
      // ディレクトリリストの作成
      foreach(string s in this.copyDirectory.Items)
        list.Add(s);
      setting.DirList = list.ToArray();
      this.copyDirectory.Items.AddRange(setting.DirList);
      setting.CopyDirectory = this.copyDirectory.Text;
      setting.CreateM3U = this.createM3u.Checked;
      setting.MP3Only = this.mp3Only.Checked;
      setting.AutoTestPlay = this.autoTestPlay.Checked;
    }
  }
}